<?php 

if (!defined('FORUM')) die();

// Start a topic
if ($action == 'topic_starter')
{
	$tid = isset($_GET['tid']) ? intval($_GET['tid']) : 0;
	if ($tid < 1)
		message($lang_common['Bad request']);

	if (file_exists($ext_info['path'].'/lang/'.$forum_user['language'].'.php') )
		include $ext_info['path'].'/lang/'.$forum_user['language'].'.php';
	else
		include $ext_info['path'].'/lang/English.php';
	
	if (!$forum_user['is_admmod'] && $forum_user['g_pan_topic_starter'] < '1')
		message($lang_pan_topic_starter['access_denied']);
	
	// We validate the CSRF token. If it's set in POST and we're at this point, the token is valid.
	// If it's in GET, we need to make sure it's valid.
	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('topic_starter'.$tid)))
		csrf_confirm_form();

	$time_now = time();

	// Get the topic subject
	$query = array(
		'SELECT'	=> 't.poster, t.subject, t.last_post_id, t.last_poster, t.forum_id, t.last_post',
		'FROM'		=> 'topics AS t',
		'WHERE'		=> 't.id='.$tid
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$topic_starter_info = $forum_db->fetch_assoc($result);

	if (!$topic_starter_info)
		message($lang_common['Bad request']);
	
	if (!$forum_user['is_admmod'] && ($forum_user['username'] != $topic_starter_info['poster']))
		message($lang_pan_topic_starter['access_denied']);
	
	//86400=1DAY//604800=1WEEK//2591000=1MONTH
	$pan_topic_starter_period = $forum_user['g_pan_topic_starter']*86400;
	
	if ($topic_starter_info['last_post'] > ($time_now - $pan_topic_starter_period))
		message($lang_pan_topic_starter['please_wait']);
	
	
	
	
	//+++++++++++++++++ OLD
	/*
	$query = array(
		'UPDATE'	=> 'topics',
		'SET'		=> 'last_post='.$time_now,
		'WHERE'		=> 'id='.$tid
	);
	
	//Who update a topic
	if ($forum_user['is_admmod'])
		$query['SET'] .= ', pan_topic_starter=1';
	else
		$query['SET'] .= ', pan_topic_starter=2';
	
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	$query = array(
		'UPDATE'	=> 'posts',
		'SET'		=> 'posted='.$time_now,
		'WHERE'		=> 'id='.$topic_starter_info['last_post_id']
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	$query = array(
		'UPDATE'	=> 'forums',
		'SET'		=> 'last_post='.$time_now.', last_post_id='.$topic_starter_info['last_post_id'].', last_poster=\''.$forum_db->escape($topic_starter_info['last_poster']).'\'',
		'WHERE'		=> 'id='.$topic_starter_info['forum_id']
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	*/
	//+++++++++++++++ OLD
	
	
	
	//+++++++++++++++++ NEW
	$query = array(
		'UPDATE'	=> 'topics',
		'SET'		=> 'last_post='.$time_now,
		'WHERE'		=> 'id='.$tid
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	$query = array(
		'UPDATE'	=> 'posts',
		'SET'		=> 'posted='.$time_now,
		'WHERE'		=> 'id='.$topic_starter_info['last_post_id']
	);
	
	//Who update a topic
	if ($forum_user['is_admmod'])
		$query['SET'] .= ', pan_topic_starter=1';
	else
		$query['SET'] .= ', pan_topic_starter=2';
	
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	$query = array(
		'UPDATE'	=> 'forums',
		'SET'		=> 'last_post='.$time_now.', last_post_id='.$topic_starter_info['last_post_id'].', last_poster=\''.$forum_db->escape($topic_starter_info['last_poster']).'\'',
		'WHERE'		=> 'id='.$topic_starter_info['forum_id']
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	//+++++++++++++++ NEW
	
	
	$forum_flash->add_info('This topic was updated');

	redirect(forum_link($forum_url['topic'], array($tid, sef_friendly($$topic_starter_info['subject']))), $lang_misc['Stick topic redirect']);
}

